// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"

extern THREADLIST *pFirstThread;

BOOL bStrict = TRUE;

// IPAhX񂩂ǂ`FbN
//		p1	string
EXPORT BOOL WINAPI isip(BMSCR *bm, char *p1, int p2, int p3)
{
	return (inet_addr(p1) != INADDR_NONE) ? -1 : 0;
}


// get local machine's ip address
//		p1	pointer to string
EXPORT BOOL WINAPI ownip(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	if ( InitWSA() ) return -1;		// WinSockG[

	char name[256];
	HOSTENT *pEnt;
	IN_ADDR in;

	if ( gethostname(name, sizeof(name)) == SOCKET_ERROR )
		return -2;

	pEnt = gethostbyname(name);
	in.s_addr = *(unsigned long *)pEnt->h_addr_list[0];
	strcpy(p1, inet_ntoa(in));
	return 0;
}






// \PbgB\Pbg̎ʂ̋ʖ
//		p1	\Pbgnh
EXPORT BOOL WINAPI netclose(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	if (! IsSocketHandle(tl, ST_ALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;
	DeleteThread(tl);
	return 0;
}



// G[R[h擾B\Pbg̎ʂ̋ʖ
//		p1	G[R[hϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI neterror(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	THREADLIST *tl = (LPTHREADLIST)p2;
	if (! IsSocketHandle(tl, ST_ALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;
	tl->ti->Lock();
	*p1 = tl->ti->err;
	tl->ti->Unlock();
	return 0;
}



// \Pbgł邩H
//		p1	\Pbgnh
EXPORT BOOL WINAPI netfail(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;

	if (! IsSocketHandle(tl, ST_ALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	ti = tl->ti;
	int err = ti->err;

	if (err == 0) return 0;
	else if (err == WSAEDISCON) return -1;
	else return -2;
}





// Lȃ\Pbg`FbN
//		p1	\Pbgnh
EXPORT BOOL WINAPI issocket(int p1, int p2, int p3, int p4)
{
	if (IsSocketHandle((LPTHREADLIST)p1, ST_ALL))
		return -1;
	return 0;
}

// \Pbǧȃ`FbNv
//		No param.
EXPORT BOOL WINAPI netstrict(int p1, int p2, int p3, int p4)
{
	bStrict = TRUE;
	return 0;
}

// \Pbǧȃ`FbNvȂ
//		No param.
EXPORT BOOL WINAPI netsilent(int p1, int p2, int p3, int p4)
{
	bStrict = FALSE;
	return 0;
}

// obt@̍ő咷w
//		p1	ő咷(64)[MB]
EXPORT BOOL WINAPI netbuffer(int p1, int p2, int p3, int p4)
{
	if (p1 < 0) return -1;
	if (p1 == 0) p1 = 64;
	iMaxBuffer = p1*1024*1024;
	return 0;
}

// TCPconfiguration ݒ
//		p1	TCPMobt@TCY(4096)
//		p1	TCPMobt@TCY(16*1024)
EXPORT BOOL WINAPI tcpconf(int p1, int p2, int p3, int p4)
{
	if (pFirstThread != NULL)
		return -1;
	if (p1 <= 0) p1 = 4096;
	if (p2 <= 0) p2 = 16*1024;
	iTCPSendBuf = p1;
	iTCPRecvBuf = p2;
	return 0;
}




EXPORT BOOL WINAPI netbindif(BMSCR *bm, char *p1, int p2, int p3)
{
	gBindAddress = inet_addr(p1);
	if (gBindAddress == htonl(INADDR_NONE))
		gBindAddress = htonl(INADDR_ANY);
	return 0;
}



EXPORT BOOL WINAPI netextra(void *p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p2;
	if (! IsSocketHandle(tl, ST_ALL))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;
	switch(p3) {
	case 0:
		*(int *)p1 = (int)tl->ti->soc;
		break;
	case 1:
		*(int *)p1 = (int)tl->hWnd;
		break;
	case -1:
		*(int *)p1 = (int)GetModuleHandle("winsock.dll");
		break;
	}
	return 0;
}






// WSA
//		B
EXPORT BOOL WINAPI netinit(int p1, int p2, int p3, int p4)
{
	if (InitWSA())
		return -1;
	return 0;
}



// PCBNET̎gpĂ郊\[XׂĊJ
//		B
EXPORT BOOL WINAPI netclear(int p1, int p2, int p3, int p4)
{
	DestroyThread();
	return 0;
}