// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"


// UDP\Pbg쐬Aڑ
//		p1	\Pbgnhi[ϐ
//		p2	BIND|[g
//		p3	LtO
EXPORT BOOL WINAPI udpsock(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	if ( InitWSA() ) return -1;		// WinSockG[

	/*  `FbNT  */
	if (p2 < 0 || p2 >= 65536) return -4;

	THREADLIST *tl;
	tl = CreateSocketThread(ST_UDP);
	if (tl == NULL)
		return -2;			//	ThreadG[

	if (p3 != 0) {
		BOOL b = TRUE;
		tl->ti->Lock();
		setsockopt(tl->ti->soc, SOL_SOCKET, SO_REUSEADDR, (char *)&b, sizeof(b));
		tl->ti->Unlock();
	}

	if ( SendMessage(tl->hWnd, WM_BIND, (WPARAM)p2, 0) != 0 ) {
		DeleteThread(tl);
		return -3;			//	BindG[
	}
	*p1 = (int)tl;
	return 0;
}


// UDP\Pbg̑Mw肷
//		p1	\Pbgnh
//		p2	MAhX
//		p3	M|[g
EXPORT BOOL WINAPI udpsendto(int p1, char *p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	/*  `FbNT  */
	if (p3 <= 0 || p3 >= 65536) return 0;

	SendMessage(tl->hWnd, WM_SENDTO, (WPARAM)p3, (LPARAM)p2);

	return 0;
}

// UDP\Pbgڑς݂ǂ擾
//		p1	ԕϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpiscon(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;

	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;

	int ret;
	ti = tl->ti;
	ti->Lock();
	if ( ti->err != 0 )
		ret = -3;		//	G[
	else if ( ti->udp.addr == htonl(INADDR_ERROR) )
		ret = -2;		//	Ɏs
	else if ( ti->udp.addr == htonl(INADDR_NONE) )
		ret = 0;		//	wor
	else
		ret = -1;		//	ݒς
	ti->Unlock();

	return ret;
}



// UDP\PbgCount
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpcount(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;

	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	ti = tl->ti;
	ti->Lock();
	*p1 = ti->udp.r->GetNextLength();
	ti->Unlock();
	return 0;
}



// pPbg擾
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpcheck(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	ti = tl->ti;
	ti->Lock();
	*p1 = ti->udp.r->CountPacket();
	ti->Unlock();
	return 0;
}





// ŌɎMUDPf[^O̔M擾
//		p1	ϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpinfo(char *p1, int p2, int p3, int p4)
{
	*p1 = '\0';
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;

	struct in_addr inaddr;
	char *p, s[16];

	ti = tl->ti;
	ti->Lock();
	if (ti->udp.fromaddr == htonl(INADDR_NONE)) {
		ti->Unlock();
		return -1;
	}
	inaddr.s_addr = ti->udp.fromaddr;
	p = inet_ntoa(inaddr);
	if (p == NULL) {
		ti->Unlock();
		return -2;
	}
	strcpy(p1, p);
	_itoa((int)ntohs(ti->udp.fromport), s, 10);
	strcat(p1, ":");
	strcat(p1, s);
	ti->Unlock();
	return 0;
}



// UDP\PbgLocalPort擾
//		p1	lϐ
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpport(int *p1, int p2, int p3, int p4)
{
	*p1 = 0;
	THREADLIST *tl = (LPTHREADLIST)p2;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -1;

	struct sockaddr_in addr;
	int len = sizeof(addr);

	ti = tl->ti;
	ti->Lock();
	getsockname(ti->soc, (struct sockaddr *)&addr, &len);
	*p1 = (int)ntohs(addr.sin_port);
	ti->Unlock();
	return 0;
}



// UDP\PbgBlockingԂ擾
//		p1	\Pbgnh
EXPORT BOOL WINAPI udpsent(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	BOOL bBlocking;

	ti = tl->ti;
	ti->Lock();
	bBlocking = ti->udp.bBlocking;
	ti->Unlock();
	return bBlocking ? 0 : -1;
}



// UDP̍őDatagramTCY擾
//		p1	lϐ
EXPORT BOOL WINAPI udpmax(int *p1, int p2, int p3, int p4)
{
	*p1 = (int)GetMaxUdpDg();
	return 0;
}













// UDP\PbgRead
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI udprecv(char *p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p4;
	THREADINFO *ti;
	int n;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;

	/*  `FbNT  */
	if (p2 < 0 || p3 < 0) return 0;

	struct sockaddr_in addr;

	ti = tl->ti;
	if (ti->err != 0) return 0;
	ti->Lock();
	n = ti->udp.r->Read(p1+p2, &addr, p3);
	ti->udp.fromaddr = addr.sin_addr.s_addr;
	ti->udp.fromport = addr.sin_port;
	ti->Unlock();
	return -n;
}


// UDP\PbgPeek
//		p1	ϐ
//		p2	ItZbg
//		p3	őMTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI udppeek(char *p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p4;
	THREADINFO *ti;
	int n;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return 0;

	/*  `FbNT  */
	if (p2 < 0 || p3 < 0) return 0;

	struct sockaddr_in addr;

	ti = tl->ti;
	if (ti->err != 0) return 0;
	ti->Lock();
	n = ti->udp.r->Peek(p1+p2, &addr, p3);
	ti->udp.fromaddr = addr.sin_addr.s_addr;
	ti->udp.fromport = addr.sin_port;
	ti->Unlock();
	return -n;
}


// UDP\PbgWrite
//		p1	ϐ
//		p2	ItZbg
//		p3	MTCY
//		p4	\Pbgnh
EXPORT BOOL WINAPI udpsend(char *p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p4;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;

	/*  `FbNT  */
	if (p2 < 0 || p3 < 0) return 0;

	struct sockaddr_in addr;

	ti = tl->ti;
	ti->Lock();
	/*
	if (ti->udp.s->Count() + p3 > iMaxBuffer) {
		ti->Unlock();
		SendMessage(tl->hWnd, WM_FATAL_CLOSE, WSAENOBUFS, 0);
		return -1;
	}
	*/
	if (ti->err != 0) {
		ti->Unlock();
		return -1;
	}
	if (( ! ( ti->udp.bBroadCast && ti->udp.addr == htonl(INADDR_BROADCAST) ) ) &&
		( ti->udp.addr == htonl(INADDR_NONE) || ti->udp.addr == htonl(INADDR_ERROR) ) ) {
		ti->Unlock();
		return -2;
	}
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = ti->udp.addr;
	addr.sin_port = ti->udp.port;
	memset(addr.sin_zero, 0, sizeof(addr.sin_zero));
	ti->udp.s->Write(p1+p2, &addr, p3);
	ti->Unlock();
	PostMessage(tl->hWnd, WM_SENDING, 0, 0);
	return 0;
}






// UDP\PbgWrite
//		p1	
//		p2	\Pbgnh
EXPORT BOOL WINAPI udpput(BMSCR *bm, char *p1, int p2, int p3)
{
	return udpsend(p1, 0, strlen(p1), p2);
}
// UDP\PbgRead
//		p1	i[ϐ
//		p2  ϐ̃TCY
//		p3	\Pbgnh
EXPORT BOOL WINAPI udpget(char *p1, int p2, int p3, int p4)
{
	BOOL ret = udprecv(p1, 0, p2-1, p3);
	p1[-ret] = '\0';
	return ret;
}



// }`LXgZbVɎQ
//		p1	\Pbgnh
//		p2	}`LXgAhX
EXPORT BOOL WINAPI udpmjoin(int p1, char *p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;

	ti = tl->ti;
	unsigned long multiaddr;
	ip_mreq mreq;
	int i, ret;

	i=0;
	while(p2[i] != '\0') {
		if (p2[i] == ':') break;
		i++;
	}
	if (p2[i] != '\0') {
		p2[i] = '\0';
		i++;
	}
	else {
		i = -1;
	}

	multiaddr = inet_addr(p2);
	if ( ntohl(multiaddr) < 0xE0000000 || ntohl(multiaddr) >= 0xF0000000)
		return -1;

	mreq.imr_multiaddr.s_addr = multiaddr;
	if (i != -1) mreq.imr_interface.s_addr = inet_addr(&(p2[i]));
	else		 mreq.imr_interface.s_addr = htonl(INADDR_ANY);

	ti->Lock();
	ret = setsockopt(ti->soc, IPPROTO_IP, IP_ADD_MEMBERSHIP,
			(char *)&mreq, sizeof(mreq));
	ti->Unlock();

	if (ret == SOCKET_ERROR) return -2;
	return 0;
}






// }`LXgZbVEނ
//		p1	\Pbgnh
//		p2	}`LXgAhX
EXPORT BOOL WINAPI udpmdrop(int p1, char *p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -3;

	ti = tl->ti;
	unsigned long multiaddr;
	ip_mreq mreq;
	int i, ret;

	i=0;
	while(p2[i] != '\0') {
		if (p2[i] == ':') break;
		i++;
	}
	if (p2[i] != '\0') {
		p2[i] = '\0';
		i++;
	}
	else {
		i = -1;
	}

	multiaddr = inet_addr(p2);
	if ( ntohl(multiaddr) < 0xE0000000 || ntohl(multiaddr) >= 0xF0000000)
		return -1;

	mreq.imr_multiaddr.s_addr = multiaddr;
	if (i != -1) mreq.imr_interface.s_addr = inet_addr(&(p2[i]));
	else		 mreq.imr_interface.s_addr = htonl(INADDR_ANY);

	ti->Lock();
	ret = setsockopt(ti->soc, IPPROTO_IP, IP_DROP_MEMBERSHIP,
			(char *)&mreq, sizeof(mreq));
	ti->Unlock();

	if (ret == SOCKET_ERROR) return -2;
	return 0;
}





// }`LXgpPbgTTLݒ肷
//		p1	\Pbgnh
//		p2	TTL̒l(1)
EXPORT BOOL WINAPI udpmttl(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	ti = tl->ti;
	int ret;

	ti->Lock();
	ret = setsockopt(ti->soc, IPPROTO_IP, IP_MULTICAST_TTL, (char *)&p2, sizeof(p2));
	ti->Unlock();

	if (ret == SOCKET_ERROR) return -1;
	return 0;
}




// TTLݒ肷
//		p1	\Pbgnh
//		p2	TTL̒l(255)
EXPORT BOOL WINAPI udpttl(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	ti = tl->ti;
	int ret;

	ti->Lock();
	ret = setsockopt(ti->soc, IPPROTO_IP, IP_TTL, (char *)&p2, sizeof(p2));
	ti->Unlock();

	if (ret == SOCKET_ERROR) return -1;
	return 0;
}









// u[hLXgAhX𑗐Mɐݒ肷
//		p1	\Pbgnh
EXPORT BOOL WINAPI udpbcast(int p1, int p2, int p3, int p4)
{
	THREADLIST *tl = (LPTHREADLIST)p1;
	THREADINFO *ti;
	if (! IsSocketHandle(tl, ST_UDP))
		if (bStrict) return HSPERROR_INVALID_SOCKET; else return -2;

	ti = tl->ti;

	int ret;
	BOOL b;

	ti->Lock();
	b = TRUE;
	ret = setsockopt(ti->soc, SOL_SOCKET, SO_BROADCAST,
			(char *)&b, sizeof(b));
	if (ret != SOCKET_ERROR) {
		ti->udp.port = htons((unsigned short)p2);
		ti->udp.addr = htonl(INADDR_BROADCAST);
		ti->udp.bBroadCast = TRUE;
	}
	ti->Unlock();

	if (ret == SOCKET_ERROR) return -1;
	return 0;
}